<?php
/*
Plugin Name: افزونه حمایت مالی نوینو پی
Plugin URI: https://novinopay.com
Description: افزونه حمایت مالی از وبسایت ها -- برای استفاده تنها کافی است کد زیر را درون بخشی از برگه یا نوشته خود قرار دهید  [NovinoPayDonate]
Version: 2.0
Author: NovinoPay
Author URI: https://novinopay.com
*/

defined('ABSPATH') or die('Access denied!');
define('NovinoPayDonateDIR', plugin_dir_path(__FILE__));
define('LIBDIR', NovinoPayDonateDIR . '/lib');
define('TABLE_DONATE', 'novinopay_donate');

require_once ABSPATH . 'wp-admin/includes/upgrade.php';

if (is_admin()) {
    add_action('admin_menu', 'NWD_AdminMenuItem');
    function NWD_AdminMenuItem()
    {
        add_menu_page('تنظیمات افزونه حمایت مالی - نوینو پی', 'حمایت مالی نوینو', 'administrator', 'NWD_MenuItem', 'NWD_MainPageHTML', /*plugins_url( 'myplugin/images/icon.png' )*/ '', 6);
        add_submenu_page('NWD_MenuItem', 'نمایش حامیان مالی', 'نمایش حامیان مالی', 'administrator', 'NWD_Hamian', 'NWD_HamianHTML');
    }
}

function NWD_MainPageHTML()
{
    include('NWD_AdminPage.php');
}

function NWD_HamianHTML()
{
    include('NWD_Hamian.php');
}


add_action('init', 'NovinoPayDonateShortcode');
function NovinoPayDonateShortcode()
{
    add_shortcode('NovinoPayDonate', 'NovinoPayDonateForm');
}

function NovinoPayDonateForm()
{
    $out = '';
    $error = '';
    $message = '';

    $MerchantID = get_option('NWD_MerchantID');
    $NWD_IsOK = get_option('NWD_IsOK');
    $NWD_IsError = get_option('NWD_IsError');
    $NWD_Unit = get_option('NWD_Unit');

    $Amount = '';
    $Description = '';
    $Name = '';
    $Mobile = '';
    $Email = '';

    //////////////////////////////////////////////////////////
    //            REQUEST
    if (isset($_POST['submit']) && $_POST['submit'] == 'پرداخت') {

        if ($MerchantID == '') {
            $error = 'مرچنت کد درگاه وارد نشده است' . "<br>\r\n";
        }


        $Amount = filter_input(INPUT_POST, 'NWD_Amount', FILTER_SANITIZE_SPECIAL_CHARS);

        if (is_numeric($Amount) != false) {
            //Amount will be based on rial  - Required
            if ($NWD_Unit == 'ریال')
                $SendAmount = $Amount / 10;
            else
                $SendAmount = $Amount;
        } else {
            $error .= 'مبلغ به درستی وارد نشده است' . "<br>\r\n";
        }

        $Description = filter_input(INPUT_POST, 'NWD_Description', FILTER_SANITIZE_SPECIAL_CHARS);  // Required
        $Name = filter_input(INPUT_POST, 'NWD_Name', FILTER_SANITIZE_SPECIAL_CHARS);  // Required
        $Mobile = filter_input(INPUT_POST, 'mobile', FILTER_SANITIZE_SPECIAL_CHARS); // Optional
        $Email = filter_input(INPUT_POST, 'email', FILTER_SANITIZE_SPECIAL_CHARS); // Optional

        $SendDescription = $Name . ' | ' . $Mobile . ' | ' . $Email . ' | ' . $Description;

        if ($error == '') // اگر خطایی نباشد
        {
            $CallbackURL = NWD_GetCallBackURL();  // Required

            $data = [
                "merchant_id" => "{$MerchantID}",
                "amount" => ($SendAmount * 10), //// rial
                "description" => "{$SendDescription}",
                "name" => "{$Name}",
                "mobile" => "{$Mobile}",
                "email" => "{$Email}",
                "callback_url" => "{$CallbackURL}"
            ];

            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, "https://api.novinopay.com/payment/ipg/v2/request");
            curl_setopt($curl, CURLOPT_HTTPHEADER, ["Content-Type" => "application/json"]);
            curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data, JSON_UNESCAPED_UNICODE));
            curl_setopt($curl, CURLOPT_TIMEOUT, 50);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            $curl_exec = curl_exec($curl);
            curl_close($curl);

            $result = json_decode($curl_exec);

            if (isset($result->status) && $result->status == 100) {
                ///save $result->data->authority in db
                ///save $result->data->trans_id in db
                ///
                // WruteToDB
                NWD_AddDonate(array(
                    'Authority' => $result->data->authority,
                    'Name' => $Name,
                    'AmountTomaan' => $SendAmount,
                    'Mobile' => $Mobile,
                    'Email' => $Email,
                    'InputDate' => current_time('mysql'),
                    'Description' => $Description,
                    'Status' => 'SEND'
                ), array(
                    '%s',
                    '%s',
                    '%d',
                    '%s',
                    '%s',
                    '%s',
                    '%s',
                    '%s'
                ));

                $Location = $result->data->payment_url;
                header("Location: {$Location}");

                return "<script>document.location = '${Location}'</script><center>در صورتی که به صورت خودکار به درگاه بانک منتقل نشدید <a href='${Location}'>اینجا</a> را کلیک کنید.</center>";


            } else {
                $error .= $result->message . "<br>\r\n";
            }


        }
    }
    //// END REQUEST


    ////////////////////////////////////////////////////
    ///             RESPONSE
    if (isset($_GET['Authority'])) {

        $Authority = filter_input(INPUT_GET, 'Authority', FILTER_SANITIZE_SPECIAL_CHARS);

        if ($_GET['PaymentStatus'] == 'OK') {

            $Record = NWD_GetDonate($Authority);
            if ($Record === false) {
                $error .= 'چنین تراکنشی در سایت ثبت نشده است' . "<br>\r\n";
            } elseif ($Record['Status'] != 'SEND') $error .= 'وضعیت تراکنش نهایی میباشد' . "<br>\r\n";
            else {

                $data = [
                    "merchant_id" => "{$MerchantID}",
                    "amount" => (int)($Record['AmountTomaan'] * 10),
                    "authority" => $Record['Authority']
                ];

                $curl = curl_init();
                curl_setopt($curl, CURLOPT_URL, "https://api.novinopay.com/payment/ipg/v2/verification");
                curl_setopt($curl, CURLOPT_HTTPHEADER, ["Content-Type" => "application/json"]);
                curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data, JSON_UNESCAPED_UNICODE));
                curl_setopt($curl, CURLOPT_TIMEOUT, 50);
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                $curl_exec = curl_exec($curl);
                curl_close($curl);

                $result = json_decode($curl_exec);

                if (isset($result->status) && $result->status == 100) {
                    NWD_ChangeStatus($Authority, 'OK');
                    $message .= get_option('NWD_IsOk') . "<br>\r\n";
                    $message .= 'کد پیگیری تراکنش:' . $result->data->ref_id . "<br>\r\n";

                    $NWD_TotalAmount = get_option("NWD_TotalAmount");
                    update_option("NWD_TotalAmount", $NWD_TotalAmount + $Record['AmountTomaan']);
                } else {
                    NWD_ChangeStatus($Authority, 'ERROR');
                    $error .= get_option('NWD_IsError') . "<br>\r\n";
                    $error .= $result->message . "<br>\r\n";
                }
            }
        } else {
            $error .= 'تراکنش توسط کاربر بازگشت خورد';
            NWD_ChangeStatus($Authority, 'CANCEL');
        }
    }
    ///     END RESPONSE

    $style = '';

    if (get_option('NWD_UseCustomStyle') == 'true') {
        $style = get_option('NWD_CustomStyle');
    } else {
        $style = '#NWD_MainForm {  width: 400px;  height: auto;  margin: 0 auto;  direction: rtl; }  #NWD_Form {  width: 96%;  height: auto;  float: right;  padding: 10px 2%; }  #NWD_Message,#NWD_Error {  width: 90%;  margin-top: 10px;  margin-right: 2%;  float: right;  padding: 5px 2%;  border-right: 2px solid #006704;  background-color: #e7ffc5;  color: #00581f; }  #NWD_Error {  border-right: 2px solid #790000;  background-color: #ffc9c5;  color: #580a00; }  .NWD_FormItem {  width: 90%;  margin-top: 10px;  margin-right: 2%;  float: right;  padding: 5px 2%; }    .NWD_FormLabel {  width: 35%;  float: right;  padding: 3px 0; }  .NWD_ItemInput {  width: 64%;  float: left; }  .NWD_ItemInput input {  width: 90%;  float: right;  border-radius: 3px;  box-shadow: 0 0 2px #00c4ff;  border: 0px solid #c0fff0;  font-family: inherit;  font-size: inherit;  padding: 3px 5px; }  .NWD_ItemInput input:focus {  box-shadow: 0 0 4px #0099d1; }  .NWD_ItemInput input.error {  box-shadow: 0 0 4px #ef0d1e; }  input.NWD_Submit {  background: none repeat scroll 0 0 #2ea2cc;  border-color: #0074a2;  box-shadow: 0 1px 0 rgba(120, 200, 230, 0.5) inset, 0 1px 0 rgba(0, 0, 0, 0.15);  color: #fff;  text-decoration: none;  border-radius: 3px;  border-style: solid;  border-width: 1px;  box-sizing: border-box;  cursor: pointer;  display: inline-block;  font-size: 13px;  line-height: 26px;  margin: 0;  padding: 0 10px 1px;  margin: 10px auto;  width: 50%;  font: inherit;  float: right;  margin-right: 24%; }';
    }


    $out = '
  <style>
    ' . $style . '
  </style>
      <div style="clear:both;width:100%;float:right;">
	        <div id="NWD_MainForm">
          <div id="NWD_Form">';

    if ($message != '') {
        $out .= "<div id=\"NWD_Message\">
    ${message}
            </div>";
    }

    if ($error != '') {
        $out .= "<div id=\"NWD_Error\">
    ${error}
            </div>";
    }

    $out .= '<form method="post">
              <div class="NWD_FormItem">
                <label class="NWD_FormLabel">مبلغ :</label>
                <div class="NWD_ItemInput">
                  <input style="width:60%" type="text" name="NWD_Amount" value="' . $Amount . '" />
                  <span style="margin-right:10px;">' . $NWD_Unit . '</span>
                </div>
              </div>
              
              <div class="NWD_FormItem">
                <label class="NWD_FormLabel">نام و نام خانوادگی :</label>
                <div class="NWD_ItemInput"><input type="text" name="NWD_Name" value="' . $Name . '" /></div>
              </div>
              
              <div class="NWD_FormItem">
                <label class="NWD_FormLabel">تلفن همراه :</label>
                <div class="NWD_ItemInput"><input type="text" name="mobile" value="' . $Mobile . '" /></div>
              </div>
              
              <div class="NWD_FormItem">
                <label class="NWD_FormLabel">ایمیل :</label>
                <div class="NWD_ItemInput"><input type="text" name="email" style="direction:ltr;text-align:left;" value="' . $Email . '" /></div>
              </div>
              
              <div class="NWD_FormItem">
                <label class="NWD_FormLabel">توضیحات :</label>
                <div class="NWD_ItemInput"><input type="text" name="NWD_Description" value="' . $Description . '" /></div>
              </div>
              
              <div class="NWD_FormItem">
                <input type="submit" name="submit" value="پرداخت" class="NWD_Submit" />
              </div>
            </form>
          </div>
        </div>
      </div>
	';

    return $out;
}

/////////////////////////////////////////////////
// تنظیمات اولیه در هنگام اجرا شدن افزونه.
register_activation_hook(__FILE__, 'NovinoPayDonate_install');
function NovinoPayDonate_install()
{
    NWD_CreateDatabaseTables();
}

function NWD_CreateDatabaseTables()
{
    global $wpdb;
    $novinoDonateTable = $wpdb->prefix . TABLE_DONATE;
    // Creat table
    $nazrezohoor = "CREATE TABLE IF NOT EXISTS `$novinoDonateTable` (
					  `DonateID` int(11) NOT NULL AUTO_INCREMENT,
					  `Authority` varchar(50) NOT NULL,
					  `Name` varchar(50) CHARACTER SET utf8 COLLATE utf8_persian_ci NOT NULL,
					  `AmountTomaan` int(11) NOT NULL,
					  `Mobile` varchar(11) ,
					  `Email` varchar(50),
					  `InputDate` varchar(20),
					  `Description` varchar(100) CHARACTER SET utf8 COLLATE utf8_persian_ci,
					  `Status` varchar(5),
					  PRIMARY KEY (`DonateID`),
					  KEY `DonateID` (`DonateID`)
					) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
    dbDelta($nazrezohoor);
    // Other Options
    add_option("NWD_TotalAmount", 0, '', 'yes');
    add_option("NWD_TotalPayment", 0, '', 'yes');
    add_option("NWD_IsOK", 'با تشکر پرداخت شما به درستی انجام شد.', '', 'yes');
    add_option("NWD_IsError", 'متاسفانه پرداخت انجام نشد.', '', 'yes');

    $style = '#NWD_MainForm {
  width: 400px;
  height: auto;
  margin: 0 auto;
  direction: rtl;
}

#NWD_Form {
  width: 96%;
  height: auto;
  float: right;
  padding: 10px 2%;
}

#NWD_Message,#NWD_Error {
  width: 90%;
  margin-top: 10px;
  margin-right: 2%;
  float: right;
  padding: 5px 2%;
  border-right: 2px solid #006704;
  background-color: #e7ffc5;
  color: #00581f;
}

#NWD_Error {
  border-right: 2px solid #790000;
  background-color: #ffc9c5;
  color: #580a00;
}

.NWD_FormItem {
  width: 90%;
  margin-top: 10px;
  margin-right: 2%;
  float: right;
  padding: 5px 2%;
}

.NWD_FormLabel {
  width: 35%;
  float: right;
  padding: 3px 0;
}

.NWD_ItemInput {
  width: 64%;
  float: left;
}

.NWD_ItemInput input {
  width: 90%;
  float: right;
  border-radius: 3px;
  box-shadow: 0 0 2px #00c4ff;
  border: 0px solid #c0fff0;
  font-family: inherit;
  font-size: inherit;
  padding: 3px 5px;
}

.NWD_ItemInput input:focus {
  box-shadow: 0 0 4px #0099d1;
}

.NWD_ItemInput input.error {
  box-shadow: 0 0 4px #ef0d1e;
}

input.NWD_Submit {
  background: none repeat scroll 0 0 #2ea2cc;
  border-color: #0074a2;
  box-shadow: 0 1px 0 rgba(120, 200, 230, 0.5) inset, 0 1px 0 rgba(0, 0, 0, 0.15);
  color: #fff;
  text-decoration: none;
  border-radius: 3px;
  border-style: solid;
  border-width: 1px;
  box-sizing: border-box;
  cursor: pointer;
  display: inline-block;
  font-size: 13px;
  line-height: 26px;
  margin: 0;
  padding: 0 10px 1px;
  margin: 10px auto;
  width: 50%;
  font: inherit;
  float: right;
  margin-right: 24%;
}';
    add_option("NWD_CustomStyle", $style, '', 'yes');
    add_option("NWD_UseCustomStyle", 'false', '', 'yes');
}

function NWD_GetDonate($Authority)
{
    global $wpdb;
    $Authority = strip_tags($wpdb->escape($Authority));

    if ($Authority == '')
        return false;

    $novinoDonateTable = $wpdb->prefix . TABLE_DONATE;

    $res = $wpdb->get_results("SELECT * FROM ${novinoDonateTable} WHERE Authority = '${Authority}' LIMIT 1", ARRAY_A);

    if (count($res) == 0)
        return false;

    return $res[0];
}

function NWD_AddDonate($Data, $Format)
{
    global $wpdb;

    if (!is_array($Data))
        return false;

    $novinoDonateTable = $wpdb->prefix . TABLE_DONATE;

    $res = $wpdb->insert($novinoDonateTable, $Data, $Format);

    if ($res == 1) {
        $totalPay = get_option('NWD_TotalPayment');
        $totalPay += 1;
        update_option('NWD_TotalPayment', $totalPay);
    }

    return $res;
}

function NWD_ChangeStatus($Authority, $Status)
{
    global $wpdb;
    $Authority = strip_tags($wpdb->escape($Authority));
    $Status = strip_tags($wpdb->escape($Status));

    if ($Authority == '' || $Status == '')
        return false;

    $novinoDonateTable = $wpdb->prefix . TABLE_DONATE;

    $res = $wpdb->query("UPDATE ${novinoDonateTable} SET `Status` = '${Status}' WHERE `Authority` = '${Authority}'");

    return $res;
}

function NWD_GetCallBackURL()
{
    $pageURL = (@$_SERVER["HTTPS"] == "on") ? "https://" : "http://";

    $ServerName = htmlspecialchars($_SERVER["SERVER_NAME"], ENT_QUOTES, "utf-8");
    $ServerPort = htmlspecialchars($_SERVER["SERVER_PORT"], ENT_QUOTES, "utf-8");
    $ServerRequestUri = htmlspecialchars($_SERVER["REQUEST_URI"], ENT_QUOTES, "utf-8");

    if ($_SERVER["SERVER_PORT"] != "80") {
        $pageURL .= $ServerName . ":" . $ServerPort . $_SERVER["REQUEST_URI"];
    } else {
        $pageURL .= $ServerName . $ServerRequestUri;
    }
    return $pageURL;
}

?>